import javax.swing.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.util.Scanner;

/**
 * Main program ServerWindow.
 * 
 * @author Stephen Bloch
 * @version 1, 8 April 2007
 */
public class ServerWindow extends JFrame
{
        // instance variables - replace the example below with your own

        /**
         * The main method, for command-line invocation.
         * 
         * @param  args   the command line arguments
         */
        public static void main (String[] args)
        {
                /*
                System.out.println ("There were " + args.length + " arguments:");
                for (int ii=0; ii<args.length; ++ii) {
                    System.out.println ("" + ii + ": " + args[ii]);
                }
                */
               javax.swing.SwingUtilities.invokeLater (new Runnable() {
                   public void run () {
                        JFrame.setDefaultLookAndFeelDecorated(true);
        
                        // Create the window and set its size.
                        new ServerWindow ();
                    }
                });
        } // end of main method
        
        public ServerWindow () {
            this.setSize (300, 600);
            this.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
            // this.add(something);
//            this.setVisible (true);
            
            this.handleConnection ();
        }
        
        private void handleConnection () {
            try {
                System.err.println ("Server starting.");
                ServerSocket ss = new ServerSocket (Constants.PORT_NUM);
                System.err.println ("Server opened ServerSocket.");
                Socket session = ss.accept ();
                System.err.println ("Server received connection.");
                InputStream inStream = session.getInputStream();
                System.err.println ("Server got input stream.");
                Scanner in = new Scanner (inStream);
                System.err.println ("Server got Scanner.");
                
                while (in.hasNext()) {
                    String message = in.nextLine();
                    System.out.println ("Server received \"" + message + "\".");
                }
                System.out.println ("Server ran out of data.  Bye now.");
                System.exit(1);
            }
            catch (IOException e) {
                System.err.println ("Server got IOException: " + e);
            }

        }
}
