import java.net.ServerSocket;
import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.IOException;
/**
 * A single thread of the server.
 * 
 * @author Stephen Bloch
 * @version 10, 11 April 2007
 * Trivial change in this version: I took out an extraneous newline in the
 * "Client says" message.
 */
public class ServerSideThread implements Runnable
{
        // instance variables
        private ServerSocket ss;
        private int clientNumber;
        
        public ServerSideThread (ServerSocket ss) {
            this.ss = ss;
        }
        
        public void run () {
            while (true) {
                Connection client = new ServerSideConnection (ss);
                this.clientNumber = TextBasedServer.getNextClientNumber();
                
                PrintWriter out = client.getOut();
                BufferedReader in = client.getIn();
                
                out.println ("Welcome, client " + this.clientNumber);
                
                while (true) { // really until end of file
                    String message;
                    try {
                        message = in.readLine();
                    }
                    catch (IOException e) {
                        System.err.println ("Server got IOException on read: " + e);
                        break;
                    }
                    if (message == null) // i.e. end of input
                    {
                        System.err.println ("Server reached end of input.");
                        break;
                    }
                    System.out.println ("Client " + this.clientNumber + " says \"" + message + "\"");
                }
                System.out.println ("Connection to client " + this.clientNumber + " closed.");
            } // end while(true)
        }            
}
