import javax.swing.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.util.Scanner;

/**
 * Main program ServerWindow.
 * 
 * @author Stephen Bloch
 * @version 2, 8 April 2007
 * 
 * In version 2, the server puts received messages into a TextArea in the window
 * rather than just sending them to System.err.
 */
public class ServerWindow extends JFrame
{
        // instance variables - replace the example below with your own
        private final static int ROWS = 40;
        private final static int COLUMNS = 60;

        /**
         * The main method, for command-line invocation.
         * 
         * @param  args   the command line arguments
         */
        public static void main (String[] args)
        {
                /*
                System.out.println ("There were " + args.length + " arguments:");
                for (int ii=0; ii<args.length; ++ii) {
                    System.out.println ("" + ii + ": " + args[ii]);
                }
                */
               javax.swing.SwingUtilities.invokeLater (new Runnable() {
                   public void run () {
                        JFrame.setDefaultLookAndFeelDecorated(true);
        
                        // Create the window and set its size.
                        new ServerWindow ();
                    }
                });
        } // end of main method
        
        public ServerWindow () {
            this.setSize (300, 600);
            this.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
            
            JTextArea log = new JTextArea (ROWS, COLUMNS);
            this.add(log);
            this.setVisible (true);
            
            this.handleConnection (log);
        }
        
        private void handleConnection (JTextArea log) {
            try {
                System.err.println ("Server starting.");
                ServerSocket ss = new ServerSocket (Constants.PORT_NUM);
                System.err.println ("Server opened ServerSocket.");
                Socket session = ss.accept ();
                System.err.println ("Server received connection.");
                InputStream inStream = session.getInputStream();
                System.err.println ("Server got input stream.");
                Scanner in = new Scanner (inStream);
                System.err.println ("Server got Scanner.");
                
                while (in.hasNext()) {
                    String message = in.nextLine();
                    log.append ("Client says \"" + message + "\"\n");
                }
                log.append ("Connection closed.");
            }
            catch (IOException e) {
                System.err.println ("Server got IOException: " + e);
            }

        }
}
