import javax.swing.*;
import java.util.Scanner;
import java.io.PrintWriter;
import java.io.IOException;

/**
 * Main program ClientWindow.
 * 
 * @author Stephen Bloch
 * @version 3, 8 April 2007
 * 
 * In this version, the ConnectionToHost is just a connection, and we write to it.
 */
public class ClientWindow extends JFrame
{
        // instance variables

        /**
         * The main method, for command-line invocation.
         * 
         * @param  args   the command line arguments
         */
        public static void main (String[] args)
        {
                /*
                System.out.println ("There were " + args.length + " arguments:");
                for (int ii=0; ii<args.length; ++ii) {
                    System.out.println ("" + ii + ": " + args[ii]);
                }
                */
               javax.swing.SwingUtilities.invokeLater (new Runnable() {
                   public void run () {
                        JFrame.setDefaultLookAndFeelDecorated(true);
        
                        // Create the window and set its size.
                        new ClientWindow ("localhost");
                    }
                });
        } // end of main method
        
        public ClientWindow (String hostname) {
            super("Client version 1");
            this.setSize (300, 600);
            this.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
            // this.add(something);
//            this.setVisible (true);
            
            Connection host = new ConnectionToHost (hostname);
            PrintWriter out = host.getOut();
            Scanner in = host.getIn();
            out.println ("Hi there!");
            out.println ("Are you there?");
            String reply = in.nextLine();
            System.out.println ("Host says \"" + reply + "\".");
            out.println ("Bye now.");
            try {
                host.close();
            }
            catch (IOException e) {
                System.err.println ("Client failed to close connection: " + e);
            }
            System.exit (1);
        }
}
