import javax.swing.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.util.Scanner;

/**
 * Main program ServerWindow.
 * 
 * @author Stephen Bloch
 * @version 3, 8 April 2007
 * 
 * In version 2, the server creates a ServerSideConnection and does the reading
 * and writing itself.  If we receive the message "Are you there?", we reply
 * "Yes, I'm here."; otherwise we just display the message in the TextArea.
 */
public class ServerWindow extends JFrame
{
        // instance variables - replace the example below with your own
        private final static int ROWS = 40;
        private final static int COLUMNS = 60;

        /**
         * The main method, for command-line invocation.
         * 
         * @param  args   the command line arguments
         */
        public static void main (String[] args)
        {
                /*
                System.out.println ("There were " + args.length + " arguments:");
                for (int ii=0; ii<args.length; ++ii) {
                    System.out.println ("" + ii + ": " + args[ii]);
                }
                */
               javax.swing.SwingUtilities.invokeLater (new Runnable() {
                   public void run () {
                        JFrame.setDefaultLookAndFeelDecorated(true);
        
                        // Create the window and set its size.
                        new ServerWindow ();
                    }
                });
        } // end of main method
        
        public ServerWindow () {
            this.setSize (300, 600);
            this.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
            
            JTextArea log = new JTextArea (ROWS, COLUMNS);
            this.add(log);
            this.setVisible (true);
            
            
            this.handleConnection (log);
        }
        
        private void handleConnection (JTextArea log) {
            Connection client = new ServerSideConnection ();
            PrintWriter out = client.getOut();
            Scanner in = client.getIn();
            
            while (in.hasNext()) {
                String message = in.nextLine();
                log.append ("Client says \"" + message + "\"\n");
                if (message.equals("Are you there?")) {
                    out.println ("Yes, I'm here.");
                }
            }
            log.append ("Connection closed.");
        }
}
