import java.io.*;
import java.net.Socket;
import java.util.Scanner;
/**
 * Write a description of class ConnectionToHost here.
 * 
 * @author Stephen Bloch
 * @version 3, April 8 2007
 * 
 * In this version, we set up both read and write access to the socket,
 * and leave it for our master to use them.
 */
public class ConnectionToHost implements Connection
{
        // instance variables
        private Socket s;
        private PrintWriter out;
        private Scanner in;
        /**
         * Constructor for objects of class ConnectionToHost
         */
        public ConnectionToHost(String hostname)
        {
            OutputStream outStream;
            try {
                System.err.println ("Client creating socket; host is \"" + hostname + "\".");
                this.s = new Socket (hostname, Constants.PORT_NUM);
                System.err.println ("Client created socket successfully.  Getting output stream...");
                outStream = this.s.getOutputStream();
                System.err.println ("Client got output stream.  Creating PrintWriter....");
                this.out = new PrintWriter (outStream, true); // auto-flush
                System.err.println ("Client created PrintWriter.");
                InputStream inStream = this.s.getInputStream();
                System.err.println ("Client got input stream.  Creating Scanner....");
                this.in = new Scanner (inStream);
                System.err.println ("Client created Scanner.");
            }
            catch (java.io.IOException e) {
                System.err.println ("Client got an IOException: " + e);
            }
        }
        
        public PrintWriter getOut() {
            return this.out;
        }
        
        public Scanner getIn() {
            return this.in;
        }
        
        public void close () throws IOException {
            this.s.close();
        }
}
