import javax.swing.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.util.Scanner;

/**
 * Main program ServerWindow.
 * 
 * @author Stephen Bloch
 * @version 4, 8 April 2007
 * 
 * In version 4, the server no longer automatically replies to "Are you there?",
 * to simplify the client.
 */
public class ServerWindow extends JFrame
{
        // instance variables - replace the example below with your own
        private final static int ROWS = 40;
        private final static int COLUMNS = 60;
        private static JTextArea log = null;

        /**
         * The main method, for command-line invocation.
         * 
         * @param  args   the command line arguments
         */
        public static void main (String[] args)
        {
            /*
            System.out.println ("There were " + args.length + " arguments:");
            for (int ii=0; ii<args.length; ++ii) {
                System.out.println ("" + ii + ": " + args[ii]);
            }
            */
           javax.swing.SwingUtilities.invokeLater (new Runnable() {
               public void run () {
                    JFrame.setDefaultLookAndFeelDecorated(true);
    
                    // Create the window and set its size.
                    new ServerWindow ();
                }
            });

            Connection client = new ServerSideConnection ();
           
            while (log == null) {   // wait for the invokeLater to set up the window
                Thread.yield();
            }
            
            handleConnection (client, log);
            
        } // end of main method
        
        public ServerWindow () {
            this.setSize (300, 600);
            this.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
            
            log = new JTextArea (ROWS, COLUMNS);
            this.add(log);
            this.setVisible (true);
        }
        
        private static void handleConnection (Connection client, JTextArea log) {
            PrintWriter out = client.getOut();
            Scanner in = client.getIn();
            
            while (in.hasNext()) {
                String message = in.nextLine();
                log.append ("Client says \"" + message + "\"\n");
                System.out.println ("Client says \"" + message + "\"\n");
            }
            log.append ("Connection closed.");
            System.exit (1);
            // although in the Real World we might sit around and wait for another connection
        }
}
