import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * Write a description of class ServerSideConnection here.
 * 
 * @author Stephen Bloch
 * @version 6, 11 April 2007
 * In this version, we use BufferedReader rather than Scanner so we can
 * perhaps get it running on panther (which doesn't have Java 1.5 installed yet).
 */
public class ServerSideConnection implements Connection
{
        // instance variables
        private ServerSocket ss;
        private Socket session;
        private PrintWriter out;
        private BufferedReader in;

        /**
         * Constructor for objects of class ServerSideConnection
         */
        public ServerSideConnection()
        {
            try {
                System.err.println ("Server starting.");
                this.ss = new ServerSocket (Constants.PORT_NUM);
                System.err.println ("Server opened ServerSocket.");
                this.session = this.ss.accept ();
                System.err.println ("Server received connection.");
                OutputStream outStream = this.session.getOutputStream();
                System.err.println ("Server got output stream.");
                this.out = new PrintWriter (outStream, true); // auto-flush
                System.err.println ("Server created PrintWriter.");
                InputStream inStream = this.session.getInputStream();
                System.err.println ("Server got input stream.");
                this.in = new BufferedReader (new InputStreamReader (inStream));
                System.err.println ("Server created BufferedReader.");
            }
            catch (IOException e) {
                System.err.println ("Server got IOException: " + e);
            }
       }

       public PrintWriter getOut () {
           return this.out;
        }
        
        public BufferedReader getIn () {
            return this.in;
        }
        
        public void close () throws IOException {
            this.session.close ();
        }
}
