import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.IOException;
/**
 * Main program TextBasedServer.
 * 
 * @author Stephen Bloch
 * @version 7, 11 April 2007
 * In this version we've added a TextBasedServer in place of the ServerWindow,
 * so maybe we can get the thing to run on panther without having to mess with
 * X11 window connections and stuff like that.
 */
public class TextBasedServer
{
        /**
         * The main method, for command-line invocation.
         * 
         * @param  args   the command line arguments
         */
        public static void main (String[] args)
        {
            Connection client = new ServerSideConnection ();
            
            handleConnection (client);
        }
        
        private static void handleConnection (Connection client) {
            PrintWriter out = client.getOut();
            BufferedReader in = client.getIn();
            
            while (true) { // really until end of file
                String message;
                try {
                    message = in.readLine();
                }
                catch (IOException e) {
                    System.err.println ("Server got IOException on read: " + e);
                    break;
                }
                if (message == null) // i.e. end of input
                {
                    System.err.println ("Server reached end of input.");
                    break;
                }
                System.out.println ("Client says \"" + message + "\"\n");
            }
            System.out.println ("Connection closed.");
            System.exit (1);
            // although in the Real World we might sit around and wait for another connection
        }
            
}
