import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.IOException;
import java.net.ServerSocket;
/**
 * Main program TextBasedServer.
 * 
 * @author Stephen Bloch
 * @version 8, 11 April 2007
 * In this version, we start up 3 threads, each waiting for a connection request
 * simultaneously, so theoretically we should be able to get 3 clients talking
 * to the same server.
 */
public class TextBasedServer
{
    private static final int MAX_CLIENTS = 3;
        /**
         * The main method, for command-line invocation.
         * 
         * @param  args   the command line arguments
         */
        public static void main (String[] args)
        {
            try {
                ServerSocket ss = new ServerSocket (Constants.PORT_NUM);
                
                for (int i=0; i<MAX_CLIENTS; ++i)
                {
                    new Thread(new ServerSideThread(ss)).start();
                }
            }
            catch (IOException e)
            {
                System.err.println ("Server got IOException while creating ServerSocket: " + e);
            }
            
        }
}
